# Default Provider pygster.
#
# Provider:: default
# Cookbook:: pygster
# Author:: Greg Albrecht <gba@onbeep.com>
# Copyright:: Copyright 2014 OnBeep, Inc.
# License:: Apache License, Version 2.0
# Source:: https://github.com/onbeep-cookbooks/pygster
#


def whyrun_supported?
  false
end


action :add do
  require 'shellwords'

  new_resource.updated_by_last_action(false)

  options = Hash.new
  python_path = ''

  new_resource.prefix && options['--metric-prefix'] = new_resource.prefix
  new_resource.parser_options && options['--parser-options'] = new_resource.parser_options
  new_resource.gmetric_options && options['--gmetric-options'] = new_resource.gmetric_options
  new_resource.graphite_host && options['--graphite-host'] = new_resource.graphite_host
  new_resource.state_dir && options['--state-dir'] = new_resource.state_dir
  new_resource.output && options['--output'] = new_resource.output
  new_resource.python_path && python_path = 'PYTHONPATH=' + new_resource.python_path.join(':')

  opts = options.map{|k,v| "#{k}=#{v}"}.join(' ')

  opts = "#{opts} #{new_resource.options}" if new_resource.options

  cron "pygster #{new_resource.log_file.gsub(/\//, '_')}" do
    command "#{python_path} /usr/local/bin/pygster #{opts} #{new_resource.parser} #{Shellwords.escape(new_resource.log_file)}"
    minute "*/#{new_resource.frequency}"
    action :create
  end
end

action :remove do
  cron "pygster #{new_resource.gsub(/\//, '_')}" do
    action :delete
  end
end
